<!DOCTYPE html>
<html>

<head>
  <meta charset='utf-8'>
  <title>Pizza 365 project</title>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container">
    <p class="h3 text-center mt-5"> Chọn đồ uống </p>
    <div class="form-group col-12">
      <hr class="mt-5 mb-5" />
    </div>

    <div class="form-group">
      <label>Đồ uống:</label>
      <select id="select-element" class="form-control">
        <option>Chọn đồ uống</option>
      </select>
    </div>
    <button id="show-result" class="btn btn-primary w-25" onclick="onBtnHienThiClick()">Hiển thị</button>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading(){
      "use strict";
      //b1: đọc bỏ qua
      //b2: kiểm tra bỏ qua
      //b3: xử lý Api
      var vXmlHttp = new XMLHttpRequest(); //tạo đối tượng request
      requestApi(vXmlHttp);
      //b4: đổ dữ liêuj vào select
      vXmlHttp.onreadystatechange =
        function () {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
            console.log(vXmlHttp.responseText); //ghi response text ra console.log
            fillDataToSelect(vXmlHttp.responseText)
          }
        };
    }
    //hàm xử lý khí nhấn nút Hiển thị
    function onBtnHienThiClick(){
      //b0: tạo đối tượng thu thập
      var vObjData = {
        drinkValue: "",
        drinkText: "",
      }
      //b1: thu thập dữ liệu từ select
      thuThapDuLieu(vObjData);
      console.log(vObjData);
      //b2: kiểm tra dữ liêuj thu thập

      //b3: hiển thị
      hienThiThongTin(vObjData)
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //Hàm xử lý gửi yêu cầu sever Api
    //input là đối tượng request
    function requestApi(paramXmlHttp){
      "use strict";
      paramXmlHttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      paramXmlHttp.send();
    }
    //hàm đổ dữ liệu vào select, input là dữ liệu từ sever gửi về
    function fillDataToSelect(paramData){
      "use strict";
      console.log(paramData);
      var vObjData = JSON.parse(paramData);
      console.log(vObjData);
      var vSelect = document.getElementById("select-element");
      for(var bI = 0; bI < vObjData.length; bI++){
        var bOpt = document.createElement("option");
        bOpt.value = vObjData[bI].maNuocUong;
        bOpt.innerHTML = vObjData[bI].tenNuocUong
        vSelect.appendChild(bOpt);
      }
    }
    //hàm thu thập dữ liệu
    function thuThapDuLieu(paramData){
      var vSelect = document.getElementById("select-element");
      paramData.drinkValue = vSelect.value;
      paramData.drinkText = vSelect.options[vSelect.selectedIndex].text;
    }
    //hàm hiển thị thông tin 
    function hienThiThongTin(paramObj){
      console.log("Giá trị của select được chọn là: " + paramObj.drinkValue);
      console.log("Nội dung của select được chọn là: " + paramObj.drinkText);
    }

    //mã nguồn để load data về
    function sampleCodeLoadData() {
      var xhttp = new XMLHttpRequest();
      xhttp.onreadystatechange =
        function () {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
            console.log(xhttp.responseText); //ghi response text ra console.log
          }
        };
      xhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      xhttp.send();
    }

  </script>
</body>

</html>